= How do I add !FindBugs analysis to my project? =
[[TOC(heading=How do I...?,depth=1,HowTo/*)]]

[http://findbugs.sourceforge.net/ FindBugs] runs against compiled Java class files. It can find bad practices (e.g., 
unclosed streams, misuse of equals()/==) , null pointer dereferences, static use of non-thread safe code (e.g., 
Calendar or !DateFormat), and security issues (e.g., possible SQL injection or HTTP response splitting).

== For Maven projects ==

To use !FindBugs in a Maven project, add the following lines to your `pom.xml` file:

{{{
#!text/xml
<project>
  ...
  <reporting>
    <plugins>
      <plugin>
        <groupId>org.codehaus.mojo</groupId>
        <artifactId>findbugs-maven-plugin</artifactId>
      </plugin>
    </plugins>
  </reporting>
  ...
</project>
}}}

!FindBugs will report its findings as part of the Maven site report (`mvn site`).

== For Ant builds ==

To use !FindBugs in an Ant project, add the following files to a directory in your source tree (`tools/findbugs-2.0.0`):
 * `lib/`
   * `annotations.jar`
   * `ant.jar`
   * `asm-3.1.jar`
   * `asm-analysis-3.1.jar`
   * `asm-commons-3.1.jar`
   * `asm-tree-3.1.jar`
   * `asm-util-3.1.jar`
   * `asm-xml-3.1.jar`
   * `bcel.jar`
   * `buggy.icns`
   * `commons-lang-2.4.jar`
   * `dom4j-1.6.1.jar`
   * `findbugs-ant.jar`
   * `findbugs.jar`
   * `jaxen-1.1.1.jar`
   * `jFormatString.jar`
   * `jsr305.jar`
 * `src/`
   * `xsl/`
     * `fancy.xsl`

If you prefer to keep the !FindBug libraries outside your source tree, change the locations for the `tools.dir` and/or
the `findbugs.dir` properties in the lines below. You can use a centralized `checkstyle.xml` file (e.g., if
you want all projects to use the same rules, or check in a project-specific configuration file to your source tree.

Add the following lines to your `build.xml` file. `build.dir`, `classes.dir`, `compile.classpath`, `junit.lib.dir`, 
`src.dir`, and `test.src.dir` should be set appropriately. 

{{{
#!text/xml
  <property name="tools.dir" location="tools"/>
  <property name="findbugs.dir" location="${tools.dir}/findbugs-2.0.0"/>
  <property name="findbugs.lib.dir" location="${findbugs.dir}/lib"/>

  <property name="report.dir" location="${build.dir}/reports"/>
  <property name="findbugs.report.dir" location="${report.dir}/findbugs"/>

  <path id="test.classpath">
    <path refid="compile.classpath"/>
    <fileset dir="${junit.lib.dir}" includes="**/*.jar"/>
  </path>
  <path id="findbugs.classpath">
    <path refid="test.classpath"/>
    <fileset dir="${findbugs.lib.dir}" includes="findbugs-ant.jar"/>
  </path>

  <taskdef name="findbugs" classname="edu.umd.cs.findbugs.anttask.FindBugsTask" classpathref="findbugs.classpath"/>

  <target name="findbugs" depends="compile" description="Analyze the source code with FindBugs">
    <property name="findbugs.report.xml" location="${findbugs.report.dir}/findbugs.xml"/>
    <mkdir dir="${findbugs.report.dir}"/>
    <findbugs home="${findbugs.dir}" output="xml:withMessages" outputFile="${findbugs.report.xml}"
        jvmargs="-Xmx256M" effort="max" projectName="${ant.project.name}"
        auxClasspathRef="findbugs.classpath" sourcePath="${src.dir}">
      <class location="${classes.dir}"/>
    </findbugs>
	
    <property name="findbugs.report.html" location="${findbugs.report.dir}/index.html"/>
    <xslt in="${findbugs.report.xml}" style="${findbugs.dir}/src/xsl/fancy.xsl" out="${findbugs.report.html}"/>
    <echo message="FindBugs report is at ${findbugs.report.html}"/>
  </target>
}}}

== Customizing rules ==

To customize how !FindBugs analyzes your code, you can use [http://findbugs.sourceforge.net/manual/filter.html filter files] to
include and/or exclude which rules, classes, or methods are reported on.

For Ant, the filter files are specified as attributes of the `findbugs` task:
{{{
#!text/xml
    <findbugs home="${findbugs.dir}" output="xml:withMessages" outputFile="${findbugs.report.xml}"
        jvmargs="-Xmx256M" effort="max" projectName="${ant.project.name}"
        auxClasspathRef="findbugs.classpath" sourcePath="${src.dir}"
        excludeFilter="my-exclude-filter.xml" includeFilter="my-include-filter.xml">
      <class location="${classes.dir}"/>
    </findbugs>
}}}

For Maven, the filter files are specified in a `configuration` tag:
{{{
#!text/xml
      <plugin>
        <groupId>org.codehaus.mojo</groupId>
        <artifactId>findbugs-maven-plugin</artifactId>
        <configuration>
          <excludeFilterFile>my-exclude-filter.xml</excludeFilterFile>
          <includeFilterFile>my-include-filter.xml</includeFilterFile>
        </configuration>
      </plugin>
}}}

=== More information ===

 * [http://mojo.codehaus.org/findbugs-maven-plugin/plugin-info.html Maven options]
 * [http://findbugs.sourceforge.net/manual/anttask.html Ant options]
 
<%= node['trac']['wiki']['footer'] %>